﻿;
; File: Test.pb
; Copyright (C) Philipp Isserstedt, 2011
;
; This program is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.
; 
; This software is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY Or FITNESS for A PARTICULAR PURPOSE. See the
; GNU General Public License for more details.
; 
; You should have received a copy of the GNU General Public License.
; If not, see <http://www.gnu.org/licenses/>.
;

EnableExplicit
IncludeFile "Parser.pb"

Procedure.d MyExp(Array Arguments.d(1))
	ProcedureReturn Exp(Arguments(0))
EndProcedure

Procedure.d MySin(Array Arguments.d(1))
	ProcedureReturn Sin(Arguments(0))
EndProcedure

Define Environment.InterpreterEnvironment
Define Error.InterpreterError
Define Result.d 

Environment\Constants("pi") = #PI
Environment\Constants("e") = #E
Environment\Functions("exp")\NumberOfArguments = 1
Environment\Functions("exp")\Eval = @MyExp()
Environment\Functions("sin")\NumberOfArguments = 1
Environment\Functions("sin")\Eval = @MySin()

Result = Parse("exp(sin(2*pi))+3*5", @Environment, @Error)

If IsNAN(Result)
	Debug Error\Type
	Debug Error\Info1
	Debug Error\Info2
Else
	Debug Result
EndIf

; IDE Options = PureBasic 4.51 (Windows - x64)
; CursorPosition = 9
; Folding = -
; EnableUnicode
; EnableXP
; CompileSourceDirectory