﻿;
; File: Token.pb
; Copyright (C) Philipp Isserstedt, 2011
; 
; This program is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.
; 
; This software is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY Or FITNESS for A PARTICULAR PURPOSE. See the
; GNU General Public License for more details.
; 
; You should have received a copy of the GNU General Public License.
; If not, see <http://www.gnu.org/licenses/>.
;

; -----------------------------------------------------
;-> Constants
; -----------------------------------------------------

Enumeration
	#TokenType_Plus				; +
	#TokenType_Minus			; -
	#TokenType_Dot				; *
	#TokenType_Slash			; /
	#TokenType_Number			; 0,...,9
	#TokenType_Identifier	; a,...,z,A,...,Z
	#TokenType_Bra				; (
	#TokenType_Ket				; )
	#TokenType_Comma			; ,
	#TokenType_EOF				; end of formula
EndEnumeration

; -----------------------------------------------------
;-> Structures
; -----------------------------------------------------

Structure Token
	Type.b
	Name.s
	Value.d
EndStructure

; -----------------------------------------------------
;-> Procedures
; -----------------------------------------------------

;
; Returns a string representation of the given token-type or "unknown" if the given token-type is unknown.
;
; Parameters:
;		TokenType : The token-type which string representation should be determined.
;
Procedure.s TokenTypeString(TokenType.b)
	Protected Name.s = "unknown"
	Select TokenType
		Case #TokenType_Plus
			Name = "+"
		Case #TokenType_Minus
			Name = "-"
		Case #TokenType_Dot
			Name = "*"
		Case #TokenType_Slash
			Name = "/"
		Case #TokenType_Number
			Name = "number"
		Case #TokenType_Identifier
			Name = "identifier"
		Case #TokenType_Bra
			Name = "("
		Case #TokenType_Ket
			Name = ")"
		Case #TokenType_Comma
			Name = ","
		Case #TokenType_EOF
			Name = "eof"
	EndSelect
	ProcedureReturn Name
EndProcedure

; IDE Options = PureBasic 4.51 (Windows - x64)
; CursorPosition = 16
; Folding = -
; EnableUnicode
; EnableXP
; CompileSourceDirectory